/*******************************************************************
**    Blink
**
**    Test of development system & comms to Arduino UNO board.
**    This sketch blinks the onboard LED once per second in a soft
**    on/off fashion using 50-Hz PWM (Pulse-Width Modulation).
**
**    Created 2011-12-26 by R. Waters
**
*******************************************************************/
const int   ledPin    = 13; // Arduino onboard LED is on Pin 13
const int   period_ms = 20; // PWM cycle time = 20 ms (50 Hz)
      int   incr_ms   = 1;  // change period this much per loop
      int   high_ms;        // time LED is ON (init to 0)
//_________________________________________________________________
//
// The setup() function is called once by the Arduino framework
// during initialization to configure the hardware I/O.
//
void setup() 
{
  pinMode(ledPin, OUTPUT); // Configure as Digital Output
}
//__________________________________________________________________
//
// The loop() function is called by the Arduino framework repeatedly.
//
void loop() 
{
  high_ms += incr_ms;             // update the PWM duty cycle
  if ((high_ms > period_ms) || (high_ms < 0)) // test max/min limit
       incr_ms = -incr_ms;        // reverse direction
  else // have not yet passed min/max duty cycle limit
  {
    digitalWrite(ledPin, HIGH);   // set the LED on
    delay(high_ms);               // wait for "high" interval
    digitalWrite(ledPin, LOW);    // set the LED off
    delay(period_ms - high_ms);   // wait remainder of period
  }
}
