
/*   EEPROM Dump   */

#include <EEPROM.h>

const int upper = 512; // size of EEPROM

void setup()
{
  byte val;
  Serial.begin(9600);
  delay(400);

  Serial.println("EEPROM Contents:");
  for (int adrs=0; adrs<upper; adrs+=16)
  {
    // Print the hex address of the first byte in this row.
    for (int i=12; i>=0; i-=4) // loop thru 4 digits
    {
      // Extract each 4-bit nibble & print it in hex
      byte nibble = (adrs >> i) & 15;
      Serial.print(nibble, HEX);
    }

    // Dump 16 bytes of hexadecimal data in a single row
    for (int ofs=0; ofs<16; ofs++)
    {
      Serial.print(" ");            // space between bytes
      val = EEPROM.read(adrs+ofs);  // read byte from EEPROM
      Serial.print(val >> 4, HEX);  // print MS nibble
      Serial.print(val & 15, HEX);  // print LS nibble
    }
    Serial.print(" ");
    for (int ofs=0; ofs<16; ofs++)  // Dump same 16 bytes as ASCII
    {
      val = EEPROM.read(adrs+ofs) & 127;
      if ((val < 32) || (val > 126))
           val = '.';
      Serial.print((char)val);
    }
    Serial.println();
  }

}

void loop()
{
}
